

clear
clc
close all
load('data1.mat');
nn = size(imuPosX,1);
%% lightHouseϵת
x =  lightHousePosX * 100;
y = -lightHousePosZ * 100;

plot(x,y,'r',imuPosX,imuPosY);

% 
errorFunction = @(params) sqrt(mean((x(1:500) * cos(params(1)) - y(1:500) * sin(params(1)) + params(2) - imuPosX(1:500)).^2 + (x(1:500) * sin(params(1)) + y(1:500) * cos(params(1)) + params(3) - imuPosY(1:500)).^2));

% ʹ fminsearch ŻҵʹСתǺλ
initialGuess = [0, 10, 10]; % ʼ²ֵ[ת, λ]
optimizedParams = fminsearch(errorFunction, initialGuess);

% ŻתǺλ
rotationAngle = optimizedParams(1);
xOffset = optimizedParams(2);
yOffset = optimizedParams(3);
% ת
xt = x * cos(rotationAngle) - y * sin(rotationAngle) + xOffset;
yt = x * sin(rotationAngle) + y * cos(rotationAngle) + yOffset;

plot(xt,yt,'r',imuPosX,imuPosY);

ds = zeros(1,length(imuDataRxTime));
for i = 1:length(imuDataRxTime)-1
    ds(i) = 1 / (imuDataRxTime(i+1)-imuDataRxTime(i));
end
plot(ds)

