function filtered_data = firstOrderFilter(data, alpha)
    % У
    if ~isvector(data)
        error('Data input must be a vector.');
    end
    if alpha < 0 || alpha > 1
        error('Alpha must be between 0 and 1.');
    end
    
    % ʼ˺
    filtered_data = zeros(size(data));
    filtered_data(1) = data(1); % ʼһԪأͨΪԭʼݵĵһֵ

    % Ӧһ׻˲
    for i = 2:length(data)
        filtered_data(i) = alpha * filtered_data(i - 1) + (1 - alpha) * data(i);
    end
end
